local vb = renoise.ViewBuilder()

local s_i,p_i,t_i,l_i,c_i
local note_val_sample_idxs ={}
local sample_idx_sample_name ={}
local map_idx =1

local order_sample_on_key =1
local tags = {'  _onset','ms'}

local val_from_selection_start
local current_window
local ptn_edtr = renoise.ApplicationWindow.MIDDLE_FRAME_PATTERN_EDITOR
local smpl_edtr = renoise.ApplicationWindow.MIDDLE_FRAME_SAMPLE_EDITOR
local sample_val,sample_name,sample_idx
local instrument_idx,delay_val
local track_delay
local track_delay_option = false
local delay_val_option = true
local rename_option = false
local nudge_ignore_option = true

---------------------------------------
-- 現在編集位置の各indexをtblに入れる。
-- pos{}.line みたいにも使ったり。
function pos (tbl)
  local ep,s
  ep = renoise.song().transport.edit_pos
  s = ep.sequence
--  tbl['sequence'] = s
  tbl['line'] = ep.line  
  tbl['pattern'] = renoise.song().sequencer:pattern(s)
  tbl['track'] = renoise.song().selected_track_index
  tbl['column'] = renoise.song().selected_note_column_index
  return tbl
end
-- 上のposの簡易版。
function pos2 ()
  local ep,s,p,t,l,c
  ep = renoise.song().transport.edit_pos
  s = ep.sequence
  l = ep.line  
  p = renoise.song().sequencer:pattern(s)
  t = renoise.song().selected_track_index
  c = renoise.song().selected_note_column_index
  return s,p,t,l,c
end

-- SampleMappingをIndexing。
-- 各note_valueをindexとして、対応するsample_index群のTableを
-- 初期値tblに収めて、変換されたtblを返す。
function note2sample_idxs(inst_idx,map_idx,tbl)
--  local tbl ={}
  local map =
  renoise.song().instruments[inst_idx].sample_mappings[map_idx]
  
  for i = 1,#map do
    local spl = map[i].sample_index
    local nt = map[i].note_range
    for j = nt[1],nt[2] do
      if type(tbl[j])~='table'
      then tbl[j] = {spl}
      else
        table.insert(tbl[j],spl)
        table.sort(tbl[j])
      end
    end
  end
  return tbl
end


-- sample_indexをindexとして、対応するsampleの名前を
-- 初期値tblに収めて返す。sample_names(2,{})という風に使ったり。
function sample_names(inst_idx,tbl)
  local spls =
  renoise.song().instruments[inst_idx].samples
  for i =1,#spls do
    tbl[i]=spls[i].name
  end
  return tbl
end


-- 上のSample etc.に関するIndexをUpdateする。
-- TrackDelayの更新も追加。
function update_sample_etc_idx (inst_idx,map_idx)
  note_val_sample_idxs[inst_idx] =
  note2sample_idxs(inst_idx,map_idx,{})
  sample_idx_sample_name[inst_idx] =
  sample_names(inst_idx,{})
  track_delay =
  renoise.song().selected_track.output_delay
end


-- Stringであるnameの中にtag1などに囲まれた数字があれば、
-- それを値として返す。+-符号(sign)付、小数点付もOKよ。
function get_val_from_name (name ,tag1,...)
  if type(name)=='string' and type(tag1)=='string'
  then
    local tag2 =...
    if tag2 ==nil then tag2 ="" else end
    local val =
    tonumber(
      string.match(
        tostring(
          string.match(name,tag1.."[-+]?%d+%.?%d*"..(tag2))),"%-?%d+%.?%d*"))
    return val
  else return nil
  end
end
  
-- Renoise NoteColumnObject から、SampleNameを割り出し、
-- tag1などに囲まれた数字があればそれを返す。
-- Sampleの名前やIndexなども色々返すように変更。
function get_tagged_val_from_note (note_column,tag1,...)
  local val
  local name,sample_idx,inst_idx
  local dly_val = note_column.delay_value
  local note_val = note_column.note_value
  
  if note_val >=0 and note_val <= 119 then
    inst_idx = note_column.instrument_value +1
    if inst_idx ==256 
    then inst_idx = 
    renoise.song().selected_instrument_index
    else end
    
    update_sample_etc_idx (inst_idx,map_idx)
    local sample_idx_tbl=
    note_val_sample_idxs[inst_idx][note_val]
    if sample_idx_tbl ~= nil then
      sample_idx = sample_idx_tbl[order_sample_on_key]
      name = sample_idx_sample_name[inst_idx][sample_idx]
    else name, sample_idx = nil, nil
    end
    val = get_val_from_name (name ,tag1,...)
  else
  end
  return val ,name ,sample_idx ,inst_idx ,dly_val
end
-- 上の簡易版
-- 
function get_val_only (note_column,tag1,...)
  local val
  local name,sample_idx,inst_idx
  local note_val = note_column.note_value
  
  if note_val >=0 and note_val <= 119 then
    inst_idx = note_column.instrument_value +1
    if note_val_sample_idxs[inst_idx] == nil
    then
     update_sample_etc_idx (inst_idx,map_idx)
    end
    local sample_idx_tbl=
    note_val_sample_idxs[inst_idx][note_val]
    if sample_idx_tbl ~= nil then
      sample_idx = sample_idx_tbl[order_sample_on_key]
      name = sample_idx_sample_name[inst_idx][sample_idx]
    else name, sample_idx = nil, nil
    end
    val = get_val_from_name (name ,tag1,...)
--  elseif note_val == 120 then
--    val = 0
  else
  end
  return val
end


-- SampleEditorに移動。
function to_sample_editor (inst_idx,smpl_idx)
  if type(smpl_idx) == 'number' and
    type(inst_idx) == 'number'
  then
    renoise.song().selected_instrument_index = inst_idx
    renoise.song().selected_sample_index = smpl_idx
    renoise.app().window.active_middle_frame =
    renoise.ApplicationWindow.MIDDLE_FRAME_SAMPLE_EDITOR
  else end
end
-- PatternEditorに移動。
function to_pattern_editor ()
  renoise.app().window.active_middle_frame =
  renoise.ApplicationWindow.MIDDLE_FRAME_PATTERN_EDITOR
end


-- Functions for Renaming etc.

-- nameから、tag1などを付随する数字と共に除去。
function remove_tag_val (name,tag1,...)
  local tag2 =...
  if tag2 ==nil then tag2 ="" else end
    
  local loc1,loc2 =
  string.find(name,tag1.."%-?%+?%d+%.?%d*"..tag2)
  if loc1 ==nil or loc2 ==nil then return name
  else
  local val =
  (name:sub(1,loc1 -1))..(name:sub(loc2 +1))
  return val
  end
end

-- http://lua-users.org/wiki/SimpleRound
function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

-- Frame数をミリ秒に変換。
-- SampleRate割り出すのに、SampleEditor上で使われる想定で
-- selected_sample使ってるので、ちょっと注意。
function frame2ms(frame)
  local init_sample_rate =
  renoise.song().selected_sample.sample_buffer.sample_rate
  local ms=
  round(1000*(frame/init_sample_rate),2)
  return ms
end

-- 選択開始点までは、どれくらいのミリ秒か。
-- -符号付。
function selection_start_2_ms_minus ()
  local init_buffer =
  renoise.song().selected_sample.sample_buffer
  local start =
  init_buffer.selection_start
  return -1*frame2ms(start -1)
end

-- 選択したSampleの名前に、与えたタグと値を付加。
function rename_selected_sample_with_tags (val,tag1,...)
  if type(val)~='number' or type(tag1)~='string' or rename_option == false
  then return nil
  else
    local sample =
    renoise.song().selected_sample
    sample.name = remove_tag_val (sample.name,tag1,...)
    sample.name = (sample.name)..tag1..tostring(val)..(...)
    update_sample_etc_idx (renoise.song().selected_instrument_index,map_idx)
  end
end

-- 選択したSampleの名前から、指定のタグとそれに付随した値を取り除く。
function remove_tags_from_selected_sample (tag1,...)
  if type(tag1)~='string' or rename_option == false
  then return nil
  else
    local sample =
    renoise.song().selected_sample
    sample.name = remove_tag_val (sample.name,tag1,...)
    update_sample_etc_idx (renoise.song().selected_instrument_index,map_idx)
  end
end


-- Delay値などの計算

-- ミリ秒が、何ラインと何Delay値分かを計算。
function ms2delay(ms)
  local bpm = renoise.song().transport.bpm
  local lpb = renoise.song().transport.lpb
  local mspl = (60*1000)/(bpm*lpb)
  if type(ms)~='number' then ms=0
  else end
  local ln , dly_l = math.modf(ms/mspl)
  local dly = round(dly_l*256)
  if dly ==256 then ln =ln +1 ; dly =0
  else end
  return ln,dly
end

-- 上の結果でDelay値を必ず正値にする。
-- TrackOutputDelayや、DelayValueも、もしあれば、計算に入れる。
function delay2delay(ms,...)
  local ln,dly
  if type(ms) ~='number' then
    ms = 0
  end
  local trk_dly,ini_dly = ...
  
  if type(trk_dly) ~= 'number' or track_delay_option == false
  then trk_dly = 0
  else end
  if type(ini_dly) ~= 'number' or delay_val_option == false
  then ini_dly = 0
  else end
  ln,dly = ms2delay(ms - trk_dly)
  if dly <0
  then ln = ln -1 ; dly = 256 +dly
  else ln =ln ; dly = dly
  end
  
  dly = dly + ini_dly
  local mod = math.modf(dly/256)
  ln = ln + mod
  dly = dly - (mod * 256)
  return ln , dly
end


-- Functions for Nudge

-- 前と次のSequenceのPatternIndexを返す。無けりゃNil。
-- デフォだとエラーが返るんで。
function pre_next_ptn (seq_pos)
  local seq_length = #(renoise.song().sequencer.pattern_sequence)
  local previous_ptn, next_ptn
  if type(seq_pos)=='number' and seq_pos <= seq_length
    and seq_pos >= 1 then
      if seq_pos > 1 and seq_pos < seq_length
      then
        previous_ptn = renoise.song().sequencer:pattern(seq_pos -1)
        next_ptn = renoise.song().sequencer:pattern(seq_pos +1)
      elseif seq_pos >= seq_length and seq_length >1
      then
        previous_ptn = renoise.song().sequencer:pattern(seq_pos -1)
        next_ptn = nil
      elseif seq_pos <= 1 and seq_length >1
      then
        previous_ptn = nil
        next_ptn = renoise.song().sequencer:pattern(seq_pos +1)
      elseif seq_length == 1
      then previous_ptn = nil ; next_ptn = nil
      else end
    else end
  return previous_ptn ,next_ptn
end

-- s_i,l_iからline分移動したときの、
-- 次のSeqencePosとLine位置を返す。
-- Delay値とかはdelay2delayとかで計算するから要らないyo。
function next_seq_line (line,s_i,l_i)
  local s_len = #(renoise.song().sequencer.pattern_sequence)
  if type(s_i)=='number' and s_i <= s_len
    and s_i >= 1 and type(line) =='number' and type(l_i) =='number'
  then
    local p_i = renoise.song().sequencer:pattern(s_i)
    local cp_len = renoise.song().patterns[p_i].number_of_lines
    local pre_ptn,nxt_ptn = pre_next_ptn (s_i)    
    local nxt_s = s_i
    local nxt_l = l_i + line
    if nxt_l <= 0 and l_i ~= 1 then
      nxt_s,nxt_l = next_seq_line(nxt_l-1,s_i,1)
    elseif nxt_l > cp_len and l_i ~= cp_len then
      nxt_s,nxt_l = next_seq_line(nxt_l - cp_len,s_i,cp_len)
    elseif line < 0 and l_i ==1 and pre_ptn ~=nil then
      nxt_s,nxt_l = next_seq_line(line +1,s_i -1,
        renoise.song().patterns[pre_ptn].number_of_lines)
    elseif line > 0 and l_i == cp_len and nxt_ptn ~= nil then
      nxt_s,nxt_l = next_seq_line(line -1,s_i +1,1)
    elseif line < 0 and l_i ==1 and pre_ptn == nil then
      nxt_s ,nxt_l = nil,nil
    elseif line > 0 and l_i == cp_len and nxt_ptn == nil then
      nxt_s ,nxt_l = nil,nil
    elseif line == 0 and l_i >= 1 and l_i <= cp_len then
      nxt_s, nxt_l = s_i, l_i
    else end
    return nxt_s,nxt_l
  else return nil,nil
  end
end

-- もしやNudge済みのやつでは？可能性があるならTrue。
-- 値を反転させて、現Sequenceから飛びでるかで判定。
function already_nudged_maybe (s_i,t_i,l_i,c_i)
  local p_i = renoise.song().sequencer:pattern(s_i)
  local note_column =
  renoise.song().patterns[p_i].tracks[t_i].lines[l_i].note_columns[c_i]
  local val =
  get_val_only (note_column,tags[1],tags[2])
  if note_column.is_empty == false and type(val) =='number' then
    local dly_val = note_column.delay_value
    local l = delay2delay(-val,0,dly_val)
    local n_s = next_seq_line (l,s_i,l_i)
    if n_s ~= s_i then
      return true
    else
      return false
    end
  else return false
  end
end

-- 次の位置を求める。次位置が塞がっていれば右隣のカラムへ。
-- Track_optionがTrueなら、次のTrack上で。どうしようもなけりゃNil
function next_pos (line,s_i,p_i,t_i,l_i,c_i,track_option)
  local max_nc =
  renoise.song().tracks[t_i].max_note_columns
  local s_nxt,l_nxt = next_seq_line (line,s_i,l_i)
  local p_nxt,c_nxt
  local t_nxt = t_i
   
  if s_nxt ~= nil 
  then
    p_nxt = renoise.song().sequencer:pattern(s_nxt)
  else t_nxt = nil
  end

  if p_nxt ~= nil and line ~= 0 and
    renoise.song().patterns[p_nxt].tracks[t_nxt].lines[l_nxt].note_columns[c_i]
    .is_empty == false
    and c_i +1 <=  max_nc
  then
      s_nxt,p_nxt,t_nxt,l_nxt,c_nxt = next_pos (line,s_i,p_i,t_i,l_i,c_i+1,track_option)
  elseif p_nxt ~= nil and line ~= 0 and
    renoise.song().patterns[p_nxt].tracks[t_nxt].lines[l_nxt].note_columns[c_i]
    .is_empty == true
  then
    c_nxt = c_i
  elseif p_nxt ~= nil and line ==0 then
    c_nxt = c_i
  else end
  -- カラムが塞がってる時のc_nxt の変更を別Trackでも反映するように
  -- ここに判定を移動。
  if track_option == true
    then
    t_nxt = t_i +1
  else end

  return s_nxt,p_nxt,t_nxt,l_nxt,c_nxt
end

-- 指定のカラムをタグに従ってNudge。
function nudge_it (s,p,t,l,c,track_option,direction)
  local x = direction
  if type(x) ~='number' then x = 1
  else x = tonumber(x) end
  local s_nxt,p_nxt,t_nxt,l_nxt,c_nxt
  local column_nxt
  local note_column =
  renoise.song().patterns[p].tracks[t].lines[l].note_columns[c]
  local ini_dly = note_column.delay_value
  local ln,dly
  local val = get_val_only (note_column,tags[1],tags[2])
  
  if val ~= nil then
    val = val * x
    ln,dly = delay2delay (val,track_delay,ini_dly)
    s_nxt,p_nxt,t_nxt,l_nxt,c_nxt =
    next_pos (ln,s,p,t,l,c,track_option)
    if s_nxt ~= nil then
    column_nxt =
    renoise.song().patterns[p_nxt].tracks[t_nxt]
    .lines[l_nxt].note_columns[c_nxt]
    else end
    if column_nxt ~= nil
      and (ln ~= 0 or track_option == true)
    then
      column_nxt:copy_from(note_column)
      column_nxt.delay_value = dly
      renoise.song().selected_sequence_index = s_nxt
      renoise.song().selected_track_index = t_nxt
      renoise.song().selected_line_index = l_nxt
      if renoise.song().tracks[t_nxt].visible_note_columns < c_nxt
      then renoise.song().tracks[t_nxt].visible_note_columns = c_nxt
      end
      renoise.song().selected_note_column_index = c_nxt
      if track_option == false then
        note_column:clear()
      end
    elseif column_nxt ~= nil and ln == 0
      and track_option == false
    then
      column_nxt.delay_value = dly
    else end
  else end
end

-- 上のNudge_itの,TrackOption==true専用カスタム版。
-- valの値を返すようにした。
function nudge_to_track (s,p,t,l,c)
  local s_nxt,p_nxt,t_nxt,l_nxt,c_nxt
  local column_nxt
  local note_column =
  renoise.song().patterns[p].tracks[t].lines[l].note_columns[c]
  local ini_dly = note_column.delay_value
  local ln,dly
  local val = get_val_only (note_column,tags[1],tags[2])
  if val ~= nil then
    ln,dly = delay2delay (val,track_delay,ini_dly)
    s_nxt,p_nxt,t_nxt,l_nxt,c_nxt =
    next_pos (ln,s,p,t,l,c,true)
    if 
    renoise.song().patterns[p_nxt].tracks[t_nxt].lines[l_nxt].note_columns[c_nxt]
    .is_empty == false
    then
    s_nxt,p_nxt,t_nxt,l_nxt,c_nxt =
    next_pos (ln,s,p,t+1,l,c_nxt,false)
    end
    
    -- パターン飛び出る奴はTrack移さない
    if s_nxt ~= nil and s_nxt ~= s then
      t_nxt = t_nxt -1
    else end
    
    if s_nxt ~= nil then
      column_nxt =
      renoise.song().patterns[p_nxt].tracks[t_nxt]
      .lines[l_nxt].note_columns[c_nxt]
    elseif s_nxt == nil then
      s_nxt,p_nxt,l_nxt,c_nxt = s,p,l,c
      t_nxt =t +1
      column_nxt =
      renoise.song().patterns[p].tracks[t_nxt]
      .lines[l].note_columns[c]
    else end
    
    if column_nxt ~= nil
    then
      column_nxt:copy_from(note_column)
      column_nxt.delay_value = dly
      if renoise.song().tracks[t_nxt].visible_note_columns < c_nxt
      then renoise.song().tracks[t_nxt].visible_note_columns = c_nxt
      end
    else end
    -- val==nilの時は放って置くように変更したため、コメントアウト。
    --[[
  elseif  val == nil and note_column.is_empty == false then
    renoise.song().patterns[p].tracks[t+1]
    .lines[l].note_columns[c]:copy_from(note_column)
    --]]
  else end
  return val
end


-- なんかButtonのPressedでエラーが出る。
-- 無名関数でLocal変数使いすぎた？謎や。
-- 試しに表現を簡易化
function nudge_plus ()
  local s,p,t,l,c = pos2()
      nudge_it (s,p,t,l,c,false,1)
end
function nudge_minus ()
  local s,p,t,l,c = pos2()  
      nudge_it (s,p,t,l,c,false,-1)
end

-- PatternTrack Nudge。
function nudge_pattern_track ()
  local time1 = os.clock()
  remove_note_notify() ; remove_notifi_selected_sample ()
  renoise.tool().app_idle_observable:remove_notifier(link_vb_to_locals)
  
  local s,p,t,l,c = pos2 ()
  local init_vis = renoise.song().tracks[t].visible_note_columns
  renoise.song():insert_track_at(t+1)
  
  for pos,line in
  renoise.song().pattern_iterator
  :note_columns_in_pattern_track(p,t,true)
  do
    if line.note_value ~= 121
      and ((nudge_ignore_option == true
      and already_nudged_maybe (s,t,pos.line,pos.column) == false)
      or nudge_ignore_option == false)
    then
      local val = nudge_to_track (s,p,t,pos.line,pos.column)
      if val ~= nil then
        line:clear()
      end
    else end    
  end 
  
  for pos,line in
  renoise.song().pattern_iterator
  :note_columns_in_pattern_track(p,t+1,true)
  do
    if line.is_empty == false then
      renoise.song().patterns[p].tracks[t]
      .lines[pos.line].note_columns[pos.column]
      :copy_from(renoise.song().patterns[p].tracks[t+1]
        .lines[pos.line].note_columns[pos.column])
    else end
  end
  local t_nxt_vis = renoise.song().tracks[t+1].visible_note_columns
  if t_nxt_vis > init_vis then
    init_vis = t_nxt_vis
  end
  if
    renoise.song().tracks[t].visible_note_columns <
    init_vis
  then
    renoise.song().tracks[t].visible_note_columns =
    init_vis
  else end
  renoise.song():delete_track_at(t+1)
  renoise.song().selected_sequence_index = s
  renoise.song().selected_track_index = t
  renoise.song().selected_line_index = l
  renoise.song().selected_note_column_index = c
  link_active_window ()
  add_vb_notify()
  local time2 = os.clock()
  print(time2-time1)
end

function undo()
  if renoise.song():can_undo() then
    renoise.song():undo()
  end
end

-- 全てのSequenceをめぐり各パターンに対して一回だけ
-- fn(seqence_index,pattern_index,...)を実行する。
function do_all_seq (fn,...)
  local seqs =renoise.song().sequencer.pattern_sequence
  local pat_done ={}
  for i=1,#seqs do
    if pat_done[seqs[i]] ~= 1
    then fn(i,seqs[i],...)
      pat_done[seqs[i]] = 1
    else
    end
  end
end


-- Track Nudge。
function nudge_track ()
   local s,p,t,l,c = pos2 ()
  renoise.song():insert_track_at(t+1)
 do_all_seq (nudge_pattern_track ())
  renoise.song().selected_sequence_index = s
  renoise.song().selected_track_index = t
  renoise.song().selected_line_index = l
  renoise.song().selected_note_column_index = c
end

  

-- Functions for Notifiers

-- notifiers for selection_start in sample editor
function link_selection_val()
  local val = selection_start_2_ms_minus ()
  vb.views.id_val_from_selection_start.text =
  tostring(val)
end
  
function add_notifi_selection ()
  local buf =
  renoise.song().selected_sample.sample_buffer
  if not(buf.selection_start_observable:has_notifier(
    link_selection_val))
  then
    buf.selection_start_observable:add_notifier(
      link_selection_val)
  end
end
function remove_notifi_selection ()
  local buf =
  renoise.song().selected_sample.sample_buffer
  if (buf.selection_start_observable:has_notifier(
    link_selection_val))
  then
    buf.selection_start_observable:remove_notifier(
      link_selection_val)
  end
end


-- notifiers for selected_sample_index_observable
function link_selected_sample_idx_etc ()
  sample_idx =
  renoise.song().selected_sample_index
  sample_name = renoise.song().selected_sample.name
  sample_val = get_val_from_name (sample_name ,tags[1],tags[2])
  instrument_idx = renoise.song().selected_instrument_index
end

function add_notifi_selected_sample ()
  if not(renoise.tool().app_idle_observable:has_notifier(
    link_selected_sample_idx_etc))
  then
    renoise.tool().app_idle_observable:add_notifier(
      link_selected_sample_idx_etc)
  end
end
function remove_notifi_selected_sample ()
  if (renoise.tool().app_idle_observable:has_notifier(
    link_selected_sample_idx_etc))
  then
    renoise.tool().app_idle_observable:remove_notifier(
      link_selected_sample_idx_etc)
  end
end


-- notifiers for note in pattern editor
function watch_pos ()
  s_i,p_i,t_i,l_i,c_i = pos2() 
end

function catch_note ()
  local note_obj =
    renoise.song().selected_note_column
  if note_obj ~=nil then
    sample_val,sample_name,sample_idx,instrument_idx,delay_val =
    get_tagged_val_from_note(note_obj,tags[1],tags[2])
  else end
end

function add_note_notify()
  if not (renoise.tool().app_idle_observable:has_notifier(watch_pos))
  then 
    renoise.tool().app_idle_observable:add_notifier(watch_pos)
    renoise.tool().app_idle_observable:add_notifier(catch_note)
  end
end

function remove_note_notify()
  if (renoise.tool().app_idle_observable:has_notifier(watch_pos)) 
  then
    renoise.tool().app_idle_observable:remove_notifier(watch_pos)
    renoise.tool().app_idle_observable:remove_notifier(catch_note)
  end
end


-- notifiers for linking vb objects to local vals
-- delay値はstring.formatで、１６進数にradix conversion。
function link_vb_to_locals ()
  vb.views.id_info1.text = ("name: "..tostring(sample_name))
  vb.views.id_info2.text = ("value: "..tostring(sample_val).." "..tags[2])
  local l,d =delay2delay (sample_val,track_delay,delay_val)
  vb.views.id_info3.text = (" →  line.delay: "
    ..tostring(l).." . "..string.upper(string.format("%x",tostring(d))))
end
function add_vb_notify()
  if not (renoise.tool().app_idle_observable:has_notifier(link_vb_to_locals))
  then 
    renoise.tool().app_idle_observable:add_notifier(link_vb_to_locals)
  end
end
function remove_vb_notify()
  if (renoise.tool().app_idle_observable:has_notifier(link_vb_to_locals))
  then 
    renoise.tool().app_idle_observable:remove_notifier(link_vb_to_locals)
    vb.views.id_info1 = nil
    vb.views.id_info2 = nil
    vb.views.id_info3 = nil   
    vb.views.id_val_from_selection_start = nil
  end
end


-- notifiers for active window
function link_active_window ()
  local active = renoise.app().window.active_middle_frame
  current_window = active
  if active == ptn_edtr
  then add_note_notify() ; remove_notifi_selected_sample ()
     vb.views.id_val_from_selection_start.text = ""
  elseif active == smpl_edtr
  then remove_note_notify() ; add_notifi_selected_sample ()
  else remove_note_notify() ; remove_notifi_selected_sample ()
  end
end

function add_window_notify()
  if not (renoise.app().window.active_middle_frame_observable:
    has_notifier(link_active_window))
  then 
    renoise.app().window.active_middle_frame_observable:
    add_notifier(link_active_window)
  end
end
function remove_window_notify()
  if (renoise.app().window.active_middle_frame_observable:
    has_notifier(link_active_window))
  then 
    renoise.app().window.active_middle_frame_observable:
    remove_notifier(link_active_window)
  end
end





-- GUI
-- GUI立ち上げ用関数
function GUI ()
  remove_vb_notify()
  remove_window_notify()
  update_sample_etc_idx (renoise.song().selected_instrument_index,map_idx)

  
-- Notifierの、link_vb_to_locals ()を参照
  local info1 =
  vb:text {
    id = "id_info1",
    text = " ",
    font = "Big"
  }
  local info2 =
  vb:text {
    id = "id_info2",
    text = " ",
    font = "Big"
  }
  local info3 =
  vb:text {
    id = "id_info3",
    text = " ",
    font = "Big"
  }
  
  local op1_txt =
  vb:text {
    text = "  -TrackDelay:",
    font = "Normal"
  }
  local option1 =
  vb:checkbox {
    value = track_delay_option,
    notifier = function(bool)
      track_delay_option = bool
    end,
  }
  
  local op2_txt =
  vb:text {
    text = "  +ColumnDelay:",
    font = "Normal"
  }
  local option2 =
  vb:checkbox {
    value = delay_val_option,
    notifier = function(bool)
      delay_val_option = bool
    end,
  }
  
  local op3_txt =
  vb:text {
    text = "  AllowRename:",
    font = "Normal"
  }
  local option3 =
  vb:checkbox {
    value = rename_option,
    notifier = function(bool)
      rename_option = bool
    end,
  }
  
  local to_smpl_edtr =
  vb:button {
    text = "To SampleEditor",
    pressed =
    function()
      to_sample_editor(instrument_idx,sample_idx)
    end
  }
  local back =
  vb:button {
    text = "Back to Pattern",
    pressed =
    function()
      to_pattern_editor()
    end
  }

  local rename_with =
  vb:button {
    text = "Rename with Tags",
    pressed =
    function()
      if type(instrument_idx) =='number' and
        type(sample_idx) =='number' and
        renoise.song().selected_sample.sample_buffer.has_sample_data
        == true
      then
        renoise.song().selected_instrument_index = instrument_idx
        renoise.song().selected_sample_index = sample_idx
        rename_selected_sample_with_tags (
          val_from_selection_start,tags[1],tags[2])
      else end
    end
  }
  local remove_tags =
  vb:button {
    text = "Remove Tags",
    pressed =
    function()
      if type(instrument_idx) =='number' and
        type(sample_idx) =='number'
      then
        renoise.song().selected_instrument_index = instrument_idx
        renoise.song().selected_sample_index = sample_idx
        remove_tags_from_selected_sample (tags[1],tags[2])
      else end
    end
  }

  
  local tag1 =
  vb:textfield {
    text = tags[1],
    notifier = function(s)
      tags[1]=s
    end
  }
  local tag2 =
  vb:textfield {
    text = tags[2],
    notifier = function(s)
      tags[2]=s
    end
  }
  local val_from =
  vb:textfield {
    id = "id_val_from_selection_start",
    text = tostring(val_from_selection_start),
    notifier = function(s)
      val_from_selection_start = tonumber(s)
    end
  }  
  local link_s =
  vb:button {
    text = "Link Selection Start",
    pressed =
    function()
      remove_notifi_selection ()
      add_notifi_selection ()
    end
  }
  local unlink_s =
  vb:button {
    text = "Unlink",
    pressed =
    function()
      remove_notifi_selection ()
    end
  }


  local nudge_it =
  vb:button {
    text = "NudgeIt",
    pressed =
    function()
      nudge_plus()
    end
  }
  
  local minus_nudge =
  vb:button {
    text = "- Nudge",
    pressed =
    function()
      nudge_minus()
    end
  }

  local pt_nudge =
  vb:button {
    text = "Nudge PatternTrack",
    pressed =
    function()
      nudge_pattern_track ()
    end
  }

  local test =
  vb:button {
    text = "test",
    pressed =
    function()
      nudge_to_track(s_i,p_i,t_i,l_i,c_i)
    end
  }
  
  local undo =
  vb:button {
    text = "undo",
    pressed =
    function()
      undo()
    end
  }
  
  -- spacingっていくつあっても最後の一回のしか効かないのね。当たり前か…。
  local s0,s1,s2,s3,s4_1,s4_2,s4,s3s4,s5_1,s5,s6
  
  s1 = vb:row{info1,spacing=10,to_smpl_edtr,back}
  s2 = vb:row{info2,info3,op1_txt,option1,op2_txt,option2,spacing=3}
  s3 = vb:row{tag1,spacing=10,val_from,spacing=10,tag2,spacing=10,link_s,unlink_s}
  s4_1 = vb:row{rename_with,spacing=10,remove_tags,}
  s4_2 = vb:row{op3_txt,option3,spacing=3}
  s4 = vb:row{s4_1,s4_2,spacing=10}
  s3s4 = vb:column{s3,s4,spacing=8,style='group',margin=5,visible=true}
  s5_1 = vb:column{nudge_it,minus_nudge,spacing=8}
  s5 = vb:row{s5_1,pt_nudge,undo,spacing=8,style='group',margin=5}
  s0 = vb:column{s1,s2,s3s4,s5,spacing=10,margin=5}
  -- 表示。
  renoise.app():show_custom_dialog("Rename with Tags" ,s0)
  
  -- notifierを起動させる。
  add_window_notify()
  link_active_window ()
  add_vb_notify()
end




